/*
    Testing class for trigger on task
*/
@isTest
public with sharing class TR_SMSWorkflow_TEST {
// Init data for testing
    static {
    	Octopush_UtilsTesting.initTestingContext_OctopushSettings();
        Octopush_UtilsTesting.initTestingContext_Contacts();
        Octopush_UtilsTesting.initTestingContext_Leads();
    }
	
	 public static testMethod void T1_WF_TaskSMS_Contact() {
	 	// Set mock callout class
		Test.setMock(HttpCalloutMock.class, new MockHttpResponseGenerator_TEST());
	 	
        Test.startTest();
        	String TECH_comment = 'OBJ=Contact|';
        	TECH_comment += 'TMP=|';
        	TECH_comment += 'SN=test|';
        	TECH_comment += 'PUR=Transactional|';
        	TECH_comment += 'MFI=mobilePhone|';
        	TECH_comment += 'ADM=|';
        	TECH_comment += 'MSG=test|';
    		Task t = new Task(
    			WhatId = null,
    			WhoId = Octopush_UtilsTesting.contacts_All[0].id,
    			subject='o_sms_TASK FROM WF',
    			description=TECH_comment,
    			status = 'Not Started',
    			priority= 'Normal'
    		); insert t;
    		
        Test.stopTest();
		list<SMS_History__c> sh = [SELECT id FROM SMS_History__c 
    							   WHERE Mobile_Number__c =: Octopush_UtilsTesting.contacts_All[0].mobilePhone
    							   AND Status__c = 'Transmitted to Octopush'
    							   AND Receiver_Type__c = 'Contact'];
		System.assertEquals(sh.size(), 1);
    }
    
    public static testMethod void T2_WF_TaskSMS_Lead() {
	 	// Set mock callout class
		Test.setMock(HttpCalloutMock.class, new MockHttpResponseGenerator_TEST());
	 	
        Test.startTest();
        	String TECH_comment = 'OBJ=Lead|';
        	TECH_comment += 'TMP=|';
        	TECH_comment += 'SN=|';
        	TECH_comment += 'PUR=Transactional|';
        	TECH_comment += 'MFI=mobilePhone|';
        	TECH_comment += 'ADM=|';
        	TECH_comment += 'MSG=test|';
    		Task t = new Task(
    			WhatId = null,
    			WhoId = Octopush_UtilsTesting.leads_All[2].id,//wrong number lead
    			subject='o_sms_TASK FROM WF 2',
    			description=TECH_comment,
    			status = 'Not Started',
    			priority= 'Normal'
    		); insert t;
        Test.stopTest();
        list<SMS_History__c> sh = [SELECT id FROM SMS_History__c 
    							   WHERE Mobile_Number__c =: Octopush_UtilsTesting.leads_All[2].mobilePhone
    							   AND Status__c = 'Error'
    							   AND Receiver_Type__c = 'Lead'];
		System.assertEquals(sh.size(), 1);
    }
}