/*
    Testing class for VF_OctopushSettings_CTRL page
*/
@isTest
public class VF_OctopushSettings_CTRL_TEST {
	
	public static testMethod void T1_Load_Existing_Settings() {
     	Octopush_UtilsTesting.initTestingContext_OctopushSettings();
        Test.startTest();
           	PageReference pageRef = Page.VF_OctopushSettings;
			Test.setCurrentPage(pageRef);
            VF_OctopushSettings_CTRL ctrl = new VF_OctopushSettings_CTRL();
            ctrl.getItems();
            system.assertEquals([SELECT id FROM Octopush_Settings__c].size(), 1);
            ctrl.save();
            system.assertEquals([SELECT id FROM Octopush_Settings__c].size(), 1);
        Test.stopTest();
    }
    
    public static testMethod void T2_No_Settings() {
        Test.startTest();
           	PageReference pageRef = Page.VF_OctopushSettings;
			Test.setCurrentPage(pageRef);
            VF_OctopushSettings_CTRL ctrl = new VF_OctopushSettings_CTRL();
            ctrl.save(); // Exception because mandatory data not fill
            system.assertEquals([SELECT id FROM Octopush_Settings__c].size(), 0);
            ctrl.os.name='OctopushSettings';
			ctrl.os.API_KEY__c='test';
			ctrl.os.User_Name__c='test@test.com';
			ctrl.os.Default_Sender_Name__c='test';
			ctrl.os.History_Recording__c=true;
			ctrl.os.Real_SMS_Sending__c=false;
			ctrl.save(); // Save OK
			system.assert(Octopush_UtilsTesting.messageContainsValue(Label.CONFIRM_SAVE_SUCCESSFUL));
			system.assertEquals([SELECT id FROM Octopush_Settings__c].size(), 1);
        Test.stopTest();
    }
}