trigger TR_SMSWorkflow on Task (after insert) {
    Task[] tasks = Trigger.new;
    // Avoid SMS Sending for bulk operation as this perform a future call to Octopush API
    // This will prevent error against callout / future calls governor limits while importing tasks or other bulk process on task
    // Only workflow on a single record is allowed (= via UI)
    if(tasks.size() ==  1) { 
        map<String, String> taskParam = new map<String, String>();
        Task t = tasks[0];
        
        if( ! String.isEmpty(t.subject) && t.subject.startsWithIgnoreCase('o_sms')) {
            if(! String.isEmpty(t.Description)) {
                String flattenDescription = t.Description.replace('\r\n', '');
                flattenDescription = flattenDescription.replace('\n', '');
                flattenDescription = flattenDescription.replace('\r', '');
                string [] allFields = flattenDescription.split('\\|', -1);
                for (String element : allFields) {
                    string [] objects = new list<String>();
                    objects = element.split('\\=', -1);  
                    system.debug('objects:'+objects);
                    if(objects.size() > 1) {           
                        if(objects[0].deleteWhitespace().equalsIgnoreCase('OBJ')) {
                            taskParam.put('OBJ', objects[1]);
                        }
                        if(objects[0].deleteWhitespace().equalsIgnoreCase('SN')) {
                             taskParam.put('SN', objects[1]);
                        }
                        if(objects[0].deleteWhitespace().equalsIgnoreCase('TMP')) {
                             taskParam.put('TMP', objects[1]);
                        }
                        if(objects[0].deleteWhitespace().equalsIgnoreCase('PUR')) {
                             taskParam.put('PUR', objects[1]);
                        }
                        if(objects[0].deleteWhitespace().equalsIgnoreCase('MFI')) {
                             taskParam.put('MFI', objects[1]);
                        }
                        if(objects[0].deleteWhitespace().equalsIgnoreCase('ADM')) {
                             taskParam.put('ADM', objects[1]);
                        }
                        if(objects[0].deleteWhitespace().equalsIgnoreCase('MSG')) {
                             taskParam.put('MSG', objects[1]);
                        }
                    }
                }
            }
            try {
            	system.debug('taskParam: '+taskParam);
                // Check if all param are set in task description
                if(taskParam.size() == 7) { 
                    String queryString = 'SELECT id, ';
                    String objectName = taskParam.get('OBJ');
                    String fieldName = taskParam.get('MFI');
                    // Check object and field input
                    if(Schema.getGlobalDescribe().containsKey(objectName)) {
                        if(Schema.getGlobalDescribe().get(objectName).getDescribe().fields.getMap().containsKey(fieldName)) {
                            if(Schema.getGlobalDescribe().get(objectName).getDescribe().fields.getMap().get(fieldName).getDescribe().isAccessible()) {
                                queryString += taskParam.get('MFI');
                                queryString += ' FROM '+objectName+' WHERE ID =\''+t.WhoId+'\'';
                                list<sObject> recipients = new list<sObject>();
                                recipients = Database.query(queryString);
                                
                                String receiverType = 'Anonymous';
                                if(t.whoid.getSobjectType() == Schema.Lead.SObjectType)
                                    receiverType = 'Lead';
                                else if(t.whoid.getSobjectType() == Schema.Contact.SObjectType)
                                    receiverType = 'Contact';
                                String mobileField = taskParam.get('MFI');  
                                String octoParams = Utils_Octopush.buildOctopushParams(taskParam.get('MSG'), recipients, taskParam.get('ADM'), mobileField);
                                String requestBody = '';        
                                requestBody += 'sms_sender='+taskParam.get('SN')+'&';
                                requestBody += taskParam.get('PUR').equalsIgnoreCase('Transactional') ? 'transactional=1&':'';   
                                requestBody += octoParams;
                                API_Octopush.sendSMSAsync(false, requestBody,  new map<String, String> {'templateID'=>taskParam.get('TMP'), 'receiverType'=>receiverType});
                            } else {
                                System.debug('OCTOPUSH LOG: Insufficent priviliges: You must have at least Read access to '+fieldName+' field on'+' '+objectName);
                            }   
                        } else {
                            System.debug('OCTOPUSH LOG: Invalid Octopush task settings: '+fieldName+' is an invalid input');
                        }   
                    } else {
                        System.debug('OCTOPUSH LOG: Invalid Octopush task settings: '+objectName+' is an invalid input');
                    }                   
                } else {
                    System.debug('OCTOPUSH LOG: SMS Task is not set with all parameters expected. Please correct your task definition: '+t.Description+' / '+taskParam.keySet());
                }
            } catch (Exception e) {
                System.debug('OCTOPUSH LOG: Exception - Invalid Octopush task settings '+e );
            }
        }
    }
}